.386
.model flat,stdcall
option casemap:none

include				bin2res.inc

.data

EmptyResSect		dd 0,000000020h,00000FFFFh,00000FFFFh,0,0,0,0
welcome				db 'Binary to resource file (.res) converter',13,10
					db 'Version 1.0 by Vortex',13,10,13,10
					db 'Usage : bin2res binaryfile.ext ResID',13,10,13,10
					db '        ResID can be a number with a leading symbol # or a string identifying',13,10
					db '        the binary data.',13,10,0
nofileext			db 'no file extension',0
memallocfail		db 'memory allocation failure',0
nofile				db 'could not open the file',0
writefailure		db 'could not write the .res file',0
IsNumber			dd 0

.data?

cmdlineparam		db 512 dup(?)				; Buffere receiving the command-line parameters
pMemInfo			READFILE_MEMINFO <?>
pFileExt			dd ?						; Pointer to source file extension
pRes				dd ?						; Pointer to destination .res file
ResDataSize			dd ?
ResName				dd ?
Addr_DataSizeField	dd ?
pFileName			dd ?						; Pointer to file name

.code

start:

	push2	esi,edi
	mov		esi,OFFSET cmdlineparam
	invoke	ParseCmdLine,esi
	cmp		eax,3
	je		@f
	invoke	ConsoleOut,ADDR welcome
	jmp		finish
@@:
	mov		eax,DWORD PTR [esi+8]
	cmp		BYTE PTR [eax],'#'					; Is the resource identifier a number?
	jne		@f
	inc		eax
	invoke	atodw,eax
	mov		IsNumber,1
@@:
	mov		ResName,eax
	mov		eax,DWORD PTR [esi+4]
	mov		pFileName,eax
	invoke	GetFileExtension,eax
	test	eax,eax
	jnz		@f
	invoke	ConsoleOut,ADDR nofileext
	jmp		finish
@@:
	mov		pFileExt,eax
	invoke	ReadFileToMem,pFileName,ADDR pMemInfo
	test	eax,MEMORY_ALLOC_FAILURE
	jz		@f

memory_err:

	invoke	ConsoleOut,ADDR memallocfail
	jmp		finish
@@:
	cmp		eax,READ_FILE_ERROR
	jne		@f
	invoke	ConsoleOut,ADDR nofile
	jmp		error1
@@:
	mov		eax,pFileExt
	mov		DWORD PTR [eax],'ser.'
	mov		edx,OFFSET pMemInfo
	mov		eax,READFILE_MEMINFO.FileSize[edx]
	mov		ResDataSize,eax
	add		eax,512
	invoke	HeapAlloc,READFILE_MEMINFO.hHeap[edx],HEAP_ZERO_MEMORY,eax
	test	eax,eax
	jnz		@f
	invoke	ConsoleOut,ADDR memallocfail
	jmp		error1
@@:
	mov		pRes,eax
	mov		edi,eax
	mov		esi,OFFSET EmptyResSect
	cld
    mov		ecx,32/4				; Size of empty resource section = 32
	rep		movsd
	lea		eax,[edi+4]
	mov		Addr_DataSizeField,eax
	mov		eax,ResDataSize
	mov		DWORD PTR [edi],eax		; Size of the binary data block
	push	0000AFFFFh				; Resource type
	pop		DWORD PTR [edi+8]
	cmp		IsNumber,1
	jne		@f
	mov		eax,ResName
	shl		eax,16
	or		eax,0FFFFh
	mov		DWORD PTR [edi+12],eax
	add		edi,4+4+4+4
	jmp		a1
@@:
	invoke	StrLenA,ResName
	mov		edx,ResName
	add		edi,4+4+4
@@:
	mov		cl,BYTE PTR [edx]
	mov		BYTE PTR [edi],cl
	add		edi,2
	add		edx,1
	sub		eax,1
	jnz		@b
	add		edi,2
	test	edi,2
	jz		a1
	add		edi,2
a1:
	mov		WORD PTR [edi+RSRC_MEMORY_FLAGS],RSRC_MOVEABLE or RSRC_PURE
	mov		WORD PTR [edi+RSRC_LANGUAGE_ID],LANGUAGE_ID
	add		edi,4+2+2+4+4
	mov		eax,edi
	mov		edx,Addr_DataSizeField
	lea		ecx,[edx-4]
	sub		eax,ecx
	mov		DWORD PTR [edx],eax
	cld
	mov		esi,DWORD PTR READFILE_MEMINFO.hMem[pMemInfo]
	mov		ecx,ResDataSize
	shr		ecx,2
	rep		movsd
	mov		ecx,ResDataSize
	and		ecx,3
	rep		movsb
	mov		eax,edi
	and		eax,3
	test	eax,eax
	jz		@f
	neg		eax
	lea		edi,[edi+eax+4]
@@:
	sub		edi,pRes
	invoke	WriteFileToDisc,pFileName,pRes,edi
	test	eax,eax
	jnz		a2
	invoke	ConsoleOut,ADDR writefailure
a2:
	invoke	HeapFree,DWORD PTR READFILE_MEMINFO.hHeap[pMemInfo],0,pRes

error1:

	invoke	FreeMemory,ADDR pMemInfo

finish:
	
	pop2	edi,esi
    invoke  ExitProcess,0
    
END start